;==================================
; MAK3DASM.ASM - Matt Pietrek 1994
;==================================
.model large
.286
extrn _CallCtl3dFromAnotherTask : PROC
extrn _OriginalTaskCSIP : DWORD

.code

public _CallCtl3dFromAnotherTask_ASM

_CallCtl3dFromAnotherTask_ASM proc
    sub     sp, 4       ; Reserve 4 bytes on stack for a return address 
    enter   0, 0

    pusha
    push    ds          ; Save original DS, and set DS to our program's DS
    mov     ds, ax      ; AX should be set to correct DGROUP from
                        ; the MakeProcInstance thunk we set up

    call    _CallCtl3dFromAnotherTask

    ; copy the OriginalTaskCSIP value into a DWORD on the stack
    mov     ax, word ptr [_OriginalTaskCSIP]
    mov     ss:[bp+2], ax
    mov     ax, word ptr [_OriginalTaskCSIP+2]
    mov     ss:[bp+4], ax

    pop     ds
    popa
    leave

    retf        ; Return to _OriginalTaskCSIP
_CallCtl3dFromAnotherTask_ASM endp

end
