//////////////////
// PRINTF1: Illustrates unsynchronized io streams
//
// To compile:
//
// bcc printf1.cpp		(Borland--works fine, cout already synchronized)
// cl  printf1.cpp		(Microsoft)
// sc  printf1.cpp		(Symantec)
//
#include <stdio.h>
#include <iostream.h>
#include <iomanip.h>

main()
{
	double pi=3.14159;		
	double e=2.71828;

	// Print pi using stdout, then cout
	printf( "pi (printf) = %7.3f\n", pi);
	cout << "pi (cout)   = " << setw(7) << setprecision(4) << pi << '\n';

	// Print e using stdout, then cout
	printf( "e  (printf) = %7.3f\n", e);
	cout << "e  (cout)   = " << setw(7) << setprecision(4) << e << '\n';

	return 0;
}
